(define-module (ui postfix-dovecot ajax)
    :use-module (alterator ajax)
    :use-module (alterator str)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

; Debug string (paste in for your needs).
; (format #t "XXX: ~S\n" rdp_profile_name)
; (format #t "[ajax, module] action info\n")

(define *is_clamav* #f)
(define *is_drweb* #f)

; To debug do:
; 1) define *debug* to #t
; 2) start ahttpd -l -d
(define *debug* #f)
(define (dmsg msg . args)
  (if *debug*
    (format #t "[ajax, postfix-dovecot]: ~S ~S\n" msg args)))

(define (ui-read)
  (let* ((data (woo-read "/postfix-dovecot"))
         (domain_master (woo-get-option (car data) 'domain_master)))
    (set! *is_clamav* (woo-get-option (car data) 'is_installed_clamsmtpd))
    (set! *is_drweb* (woo-get-option (car data) 'is_installed_drwebd))
    (dmsg "Clamav software present flag:" *is_clamav*)
    (dmsg "Domain master:" domain_master)
    (form-update-value-list data)
    (form-update-visibility "can_use_clamav" *is_clamav*)
    (form-update-visibility "can_use_drweb" *is_drweb*)
    (form-update-visibility "paranoid_cd" (and *is_clamav* *is_drweb*) )
    (form-update-visibility "paranoid_dc" (and *is_clamav* *is_drweb*) )
    (form-update-visibility "nodomain_page" (not domain_master))
    (form-update-activity "main_table"  domain_master)
    (form-update-activity "postfix_daemon"  domain_master)
    (form-update-activity "mode"  domain_master)
    (form-update-activity "relayhost"  domain_master)
    (form-update-activity "domainlist"  domain_master)
    (form-update-activity "relay"  domain_master)
    (form-update-activity "mx"  domain_master)
    (form-update-activity "rootmail"  domain_master)
    (form-update-activity "message_size_limit"  domain_master)
    (form-update-activity "spamfilter"  domain_master)
    (form-update-activity "filter_senders"  domain_master)
    (form-update-activity "mynetworks"  domain_master)
    (form-update-activity "filter_recipients"  domain_master)
    (form-update-activity "filtered_recipients"  domain_master)
    (form-update-activity "pop3_imap"  domain_master)
    (form-update-activity "apply_button"  domain_master)))


(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/postfix-dovecot"
             'language (form-value "language")
             (form-value-list))
      (ui-read)
      (update-effect))))

(define (init)
  (dmsg "'init' action")
  (form-update-enum "mode"
    (woo-list "/postfix-dovecot/modes" 'language (form-value "language")))

  (ui-read)

  (effect-show "relay" "mode" "relay")
  (effect-show "mx" "mode" "mx")
  (effect-show "recipients" "filter_recipients" #t)
  (effect-show "antiviruses" "use_antivirus" #t)
  (effect-show "main_table" "postfix_daemon" #t)
  (effect-show "sasl_table" "pop3_imap" #t)
  (effect-show "information" "chk_box_info" #t)
  (init-effect)

  (form-bind "apply_button" "click" ui-write))

; vim: ft=lisp expandtab
